"use strict";
/* eslint-disable global-require */
/* eslint-disable import/no-dynamic-require */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConfiguration = void 0;
const find_up_1 = require("find-up");
const fs_1 = require("fs");
const SUPPORTED_FILES = ['.changelogrc.js', '.changelogrc.json', '.changelogrc'];
let cachedConfig;
const getConfiguration = () => {
    if (cachedConfig) {
        return cachedConfig;
    }
    const configPath = find_up_1.sync(SUPPORTED_FILES);
    if (!configPath) {
        throw new Error(`You must provide one of the configuration files: ${SUPPORTED_FILES.join(', ')}`);
    }
    const config = configPath.endsWith('.js')
        ? require(configPath)
        : JSON.parse(fs_1.readFileSync(configPath).toString());
    config.scopes =
        config.scopes?.map((scope) => {
            const sanitizedScopeType = scope.type.trim();
            if (!sanitizedScopeType) {
                throw new Error('You provided an empty scope');
            }
            return {
                description: scope.description,
                type: sanitizedScopeType,
            };
        }) ?? [];
    if (!config.types?.length) {
        throw new Error('You must provide types');
    }
    cachedConfig = config;
    return cachedConfig;
};
exports.getConfiguration = getConfiguration;
